<template>
  <div class="project">
    <div class="card">
      <div class="btn" @click="openModal">
        +
      </div>
      <modal name="modal"
        classes="modal"
        :width=450
        :height="450"
        :adaptive="true
      ">
        <h1 class="title">Create Project</h1>
        <div class="modal-middle text">
          <FormulateForm>
            <FormulateInput v-model="name" name='name' label='Project name' label-class="input-label" validation="required" />
            <FormulateInput
                v-model="lang"
                :options="{js: 'JavaScript'}"
                type="radio"
                label="Language"
                validation="required"
            />
            <FormulateInput
                v-model="capacity"
                :options="{1: '1', 2: '2', 3: '3', 4: '4',5: '5'}"
                type="select"
                placeholder="Select an option"
                label="Capacity"
                validation="required"
            />
            <FormulateInput type="submit" @click="addProject" input-class="btn-submit" label='Create' />
          </FormulateForm>
        </div>
      </modal>
    </div>
  </div>
</template>

<script>

import Vuex from "vuex";
import fetch from "../../config/fetch";

export default {
  name: 'AddProject',

  data: function () {
    return {
      lang: 'js',
      name: '',
      capacity: 5
    }
  },
  computed: {
    ...Vuex.mapGetters(['user', 'socket']),
  },
  methods: {
    ...Vuex.mapActions(['createProject', 'getUserProjects']),
    openModal() {
      
      this.$modal.show('modal') 
    },
    addProject() {
      const data = {
        name: this.name,
        lang: this.lang,
        capacity: this.capacity,
        createdBy: this.user.id
      }
      //this.createProject(data,this.user.id)
      return fetch(process.env.VUE_APP_API_URL + '/projects/' + this.user.id, {
        method: 'POST',
        headers: {
          'Content-type': 'application/json',
          Accept: 'application/json',
        },
        body: JSON.stringify(data)
      }).then(res => {
        this.socket.emit('update-tunnel-to-listen', {id: this.user.id})
        if (res != null) {
          this.getUserProjects(this.user.id)
          this.$modal.hide('modal')
          return res
        }
      }).catch(err => {
        if (err.json) {
          return err.json.then(json => {
            console.log(json)
          })
        }
      })
    }
  }
}
</script>

<style scoped>
.card {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  border: 2px solid var(--color-primary-blue);
  border-radius: 8px;
  padding: 20px;
  width: 250px;
  min-height: 230px;
}

.btn {
  font-size: 22px;
  padding: 8px 30px;
  background-color: var(--color-primary-blue);
}

.text {
  font-size: 17px;
  font-weight: 800;
  color: black;
  margin-bottom: 8px;
}

.title {
  padding: 10px;
  margin: 0;
  width: 100%;
  border-bottom: 1px solid var(--color-primary-blue);
  text-align: left;
}

.modal-middle {
  padding: 20px;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  justify-content: flex-start;
}

.input-project-name label {
  margin-bottom: 8px;
}

</style>